#pragma once

#include <BaseMqtt/CBaseMqtt.h>

#include <zephyr/kernel.h>

#include <zephyr/net/socket.h>

#include <zephyr/posix/netdb.h>

#include <zephyr/net/net_ip.h>

#include <zephyr/net/mqtt.h>

#include <modem/lte_lc.h>


#define CONFIG_MQTT_MESSAGE_BUFFER_SIZE 128

#define CONFIG_MQTT_PAYLOAD_BUFFER_SIZE 256

class CMqttStandardThread:public CBaseMqtt
{

    static CMqttStandardThread *instance;

    static uint8_t rx_buffer[CONFIG_MQTT_MESSAGE_BUFFER_SIZE];

    static uint8_t tx_buffer[CONFIG_MQTT_MESSAGE_BUFFER_SIZE];

    static uint8_t payload_buf[CONFIG_MQTT_PAYLOAD_BUFFER_SIZE];
    
    /* MQTT Broker details. */
    static struct sockaddr_storage broker;
    
    static struct mqtt_client client;

    static int broker_init(void);

    static int client_init(struct mqtt_client *client);

    static void mqtt_evt_handler(struct mqtt_client *const c,
        const struct mqtt_evt *evt);


    struct mqtt_topic subscribe_topics[3];

    struct mqtt_subscription_list subscription_list;

    char topicSubscribed[3][64] ={};
    
    void initTopicSubscription();

public:

    CMqttStandardThread();

    virtual ~CMqttStandardThread();

    void runHandler(void) override;

    void onTimerCallback() override;

};